# RuntimeBase Class

Namespace: `ArchestrA.Toolkit`

This Class provides functionality such as, Support for Runtime Events, Add / Remove attributes, Failover Support for Dynamic Attributes, Advise Only Active support and get / set of value, time and quality for attributes.

**Syntax**

```csharp
public class RuntimeBase : AObjectBase, IPrimitiveDeployment, IValueSupport, IPrimitiveRuntimeScanOnDemandCS, IPrimitiveRuntime3, IPrimitiveRuntime
```

**Remarks**

The Runtime Base class is derived from:

AObjectBase which is a part of the ArchestrA.Toolkit namespace and IPrimitiveDeployment, IValueSupport, IPrimitiveRuntimeScanOnDemandCS, IPrimitiveRuntime2 and IPrimitiveRuntime which are the parts of the ArchestrA.Core namespace.

## RuntimeBase Properties

### DynamicAttributeFailoverEnabled Property

Indicates if fail-over support is enabled for runtime dynamic attribute.

**Syntax**

```csharp
public bool DynamicAttributeFailoverEnabled { get; }
```

**Returns**

bool

Returns true if Failover support is enabled for the object.

### ScanOnDemandEnabled Property

Indicates if the “advise only active” support is enabled for the Object. It returns true only if Advise Only Active is enabled for both the Object and the Galaxy.

**Syntax**

```csharp
public bool ScanOnDemandEnabled { get; }
```

**Returns**

bool

### Site Property

Provides access to the RuntimeSite.

**Syntax**

```csharp
public IPrimitiveRuntimeSiteEx2 Site { get; }
```

**Returns**

IPrimitiveRuntimeSiteEx2

**Remarks**

The toolkit provides wrappers for most of the commonly used functions like AddAttribute and so on. An advanced user can access additional functions from IPrimitiveRuntimeSiteEx2 using the Site Property.

Example to enable checkpoint for an attribute:

```csharp
Site2.CheckpointAttribute(attrID,true);
```

### ThisPrimitive Property

Provides access to the current Primitive ID.

**Syntax**

```csharp
public short ThisPrimitive { get; }
```

**Returns**

short

## RuntimeBase Constructor

### RuntimeBase Constructor

This is the default constructor for the RuntimeBase class. This is not used by the Object Developer. The Object Developer uses the <object>Runtime() constructor that is automatically generated by the toolkit.

**Syntax**

```csharp
public RuntimeBase();
```

## RuntimeBase Events

### RuntimeDynamic Event

Fired when the value of a runtime dynamic attribute is changed. The toolkit automatically generates code to register the delegate <objectname>Runtime_RuntimeDynamic for this event.

**Syntax**

```csharp
public event RuntimeDynamicSetHandlerDelegate RuntimeDynamic;
```

### RuntimeExecute Event

Fired on every scan cycle of the hosting AppEngine while the object is OnScan. The toolkit automatically generates code to register the delegate <objectname>_RuntimeExecute for this event.

**Syntax**

```csharp
public event RuntimeExecuteDelegate RuntimeExecute;
```

### RuntimeGetStatusDesc Event

Occurs when the run time component requests a detailed message for an error for example, after a set handler returns a failure. The toolkit automatically generates code to register the delegate <objectname>Runtime_RuntimeGetStatusDesc for this event.

**Syntax**

```csharp
public event RuntimeGetStatusDescDelegate RuntimeGetStatusDesc;
```

### RuntimeInitialize Event

Occurs after the object is created in run time (usually after deployment, but also after a failover or after the bootstrap is restarted). Occurs before the Startup event. No attribute information is available at this time. The toolkit automatically generates code to register the delegate <objectname>Runtime_RuntimeInitialize for this event.

**Syntax**

```csharp
public event RuntimeInitializeDelegate RuntimeInitialize;
```

### RuntimeSetScanState Event

Occurs when the object's scan state (OnScan/OffScan) is changed. The toolkit automatically generates code to register the delegate <objectname>_ RuntimeSetScanState for this event.

**Syntax**

```csharp
public event RuntimeSetScanStateDelegate RuntimeSetScanState;
```

### RuntimeShutdown Event

Occurs when the object is shutting down (usually after the object is set to OffScan, but during a failover OffScan may not be set). This event does not occur if the object goes off the network during a network failure. The toolkit automatically generates code to register the delegate <objectname>_RuntimeShutdown for this event.

**Syntax**

```csharp
public event RuntimeShutdownDelegate RuntimeShutdown;
```

### RuntimeStartup Event

Occurs when the object is started (after the Initialize event and before it goes OnScan). You can use the event's startup context to find out whether the object is starting up after a failover or other reasons. The toolkit automatically generates code to register the delegate <objectname>_RuntimeStartup for this event.

**Syntax**

```csharp
public event RuntimeStartupDelegate RuntimeStartup;
```

## RuntimeBase Methods

### ActivateLocalAttribute Method (string)

Provides a method to activate an attribute. This function is called by auto-generated toolkit code and is typically not to be used by the Object Developer.

**Syntax**

```csharp
public bool ActivateLocalAttribute(
string attributeName
);
```

**Parameters**

**`attributeName`**

The external name of the attribute.

**Returns**

bool

### ActivateLocalAttribute Method (short, string)

Provides a method to activate an attribute. This function is called by auto-generated toolkit code and is typically not to be used by the Object Developer.

**Syntax**

```csharp
public bool ActivateLocalAttribute(
short attributeId,
string attributeName
);
```

**Parameters**

**`attributeId`**

The attribute ID.

**`attributeName`**

The external name of the attribute.

**Returns**

bool

### ActivatePrimitiveAttribute Method (string)

Provides a method to activate an attribute of a child primitive, reusable primitive, or utility primitive.

**Syntax**

```csharp
public bool ActivatePrimitiveAttribute(
string fullAttributeName
);
```

**Parameters**

**`fullAttributeName`**

The name of the primitive attribute. The name fullAttributeName format should be "PrimitiveName.AttributeName".

**Returns**

bool

### ActivatePrimitiveAttribute Method (short, short)

Provides a method to activate an attribute of a child primitive, reusable primitive, or utility primitive.

**Syntax**

```csharp
public bool ActivatePrimitiveAttribute(
short attributeId,
short primitiveId,
);
```

**Parameters**

**`attributeId`**

The Primitive's attribute ID.

**`primitiveId`**

The Primitive ID.

**Returns**

bool

### AddAttribute Method (string, MxAttributeCategory, MxDataType, bool)

Provides a method to add a Dynamic Attribute to the Primitive. Use this function if you are adding a non-array attribute.

**Syntax**

```csharp
public bool AddAttribute(
string name,
MxAttributeCategory category,
MxDataType type,
bool setHandler
);
```

**Parameters**

Refer to the section AddAttribute Method Parameters and Return Value.

**Returns**

Refer to the section AddAttribute Method Parameters and Return Value.

### AddAttribute Method (string, MxAttributeCategory, MxDataType, bool)

Provides a method to add a Dynamic Attribute to the Primitive. Use this function if you are adding a non-array attribute.

**Syntax**

```csharp
public bool AddAttribute(
string name,
MxAttributeCategory category,
MxDataType type,
bool setHandler
);
```

**Parameters**

Refer to the section AddAttribute Method Parameters and Return Value.

**Returns**

Refer to the section AddAttribute Method Parameters and Return Value.

### AddAttribute Method (string, MxAttributeCategory, MxDataType, int, bool)

Provides a method to add a Dynamic Attribute Array.

**Syntax**

```csharp
public bool AddAttribute(
string name,
MxAttributeCategory category,
MxDataType type,
int length,
bool setHandler
);
```

**Parameters**

Refer to the section AddAttribute Method Parameters and Return Value.

**Returns**

Refer to the section AddAttribute Method Parameters and Return Value.

### AddAttribute Method (string, MxAttributeCategory, MxDataType, MxSecurityClassification, DataQuality, bool, bool, short)

Provides a detailed method to add a Dynamic Attribute. Use this function to add a non- array attribute that you want to exclude from Dump/Load.

**Syntax**

```csharp
public bool AddAttribute(
string name,
MxAttributeCategory category,
MxDataType type,
MxSecurityClassification security,
DataQuality quality,
bool setHandler,
bool excludeFromFailover,
out short id
);
```

**Parameters**

Refer to the section AddAttribute Method Parameters and Return Value.

**Returns**

Refer to the section AddAttribute Method Parameters and Return Value.

### AddAttribute Method (string, MxAttributeCategory, MxDataType, MxSecurityClassification, DataQuality, int, bool, bool, short)

Provides a detailed method to add a Dynamic Attribute Array. Use this function to add a array attribute that you want to exclude from Dump/Load.

**Syntax**

```csharp
public bool AddAttribute(
string name,
MxAttributeCategory category,
MxDataType type,
MxSecurityClassification security,
DataQuality quality,
int length,
bool setHandler,
bool excludeFromFailover,
out short id
);
```

**Parameters**

**`name`**

Refer to the section AddAttribute Method Parameters and Return Value.

**Returns**

Refer to the section AddAttribute Method Parameters and Return Value.

### AddAttribute Method Parameters and Return Value

**Parameters**

**`name`**

External name of the attribute.

**`category`**

Supported categories:

MxCategoryCalculated

MxCategoryCalculatedRetentive

MxCategoryWriteable_S

MxCategoryWriteable_U

MxCategoryWriteable_UC

MxCategoryWriteable_US

MxCategoryWriteable_USC

**`type`**

Supported data types:

MxBigString

MxBoolean

MxDataQualityType

MxDataTypeEnum

MxDouble

MxElapsedTime

MxFloat

MxInteger

MxInternationalizedString

MxNoData

MxQualifiedEnum

MxQualifiedStruct

MxReferenceType

MxSecurityClassificationEnum

MxStatusType

MxString

MxTime

**`setHandler`**

true: Enables the runtime dynamic set handler.

The user should add a case for the dynamic attribute in the <objectname>Runtime_RuntimeDynamic function, as the attribute is not set by default, when this parameter is marked as true.

**`length`**

Indicates the length of the array, pass 0 in case of non-array attribute.

**`quality`**

Supported quality types:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`security`**

Supported security classifications:

MxSecurityConfigure

MxSecurityFreeAccess

MxSecurityOperate

MxSecuritySecuredWrite

MxSecurityTune

MxSecurityUndefined

MxSecurityVerifiedWrite

MxSecurityViewOnly

**`excludeFromDumpLoad`**

If true excludes the attribute from Dumpload.

**`id`**

Out parameter with the attribute ID of newly created dynamic attribute.

**Returns**

bool

true: if the attribute is successfully added.

false: fails to add the dynamic attribute if the attribute with the provided name already exists, or if the user tries to add a attribute with unsupported category or data type.

### AppendNames Method

Appends two names together in a period separated Application Server format [owner].[child].

**Syntax**

```csharp
public string AppendNames(
string owner,
string child
);
```

**Parameters**

**`owner`**

The owner name.

**`child`**

The child name.

**Returns**

string

Returns the Archestra name in the format [owner].[child]. If either name is empty, no period is included.

### BindTo Method (string, string)

Provides a method to create an Indirect (CMxIndirect) for referencing Attributes of other Objects.

**Syntax**

```csharp
public CMxIndirect BindTo(
string refString,
string refContext
);
```

**Parameters**

**`refString`**

The reference of the attribute of another object, in the format "ObjectName.AttributeName".

**`refContext`**

An empty string is used for this parameter when the refString parameter is specified as "ObjectName.AttributeName".

When using a relative reference (like "MyArea.ScanState" or "MyPlatform.CPULoad") in the refString parameter, the refContext parameter must be the Tagname property of the object. The refContext parameter can be empty if the refString parameter contains an absolute path.

**Remarks**

After the BindTo() operation, access the value of the Indirect only if the Indirect's StatusOfLastRead.success = = -1 and StatusOfLastRead.Category = = MxStatusCategory.MxCategoryOk

**Example**

```csharp
CMxIndirect mxIndirect = BindTo("MyArea.ScanState", Tagname);
```

**Returns**

CMxIndirect

### BindTo Method (string, string, bool)

Provides a method to create an Indirect (CMxIndirect) for referencing Attributes of other Objects.

**Syntax**

```csharp
public CMxIndirect BindTo(
string refString,
string refContext,
bool suspended
);
```

**Parameters**

**`refString`**

The reference of the attribute of another object, in the format "ObjectName.AttributeName".

**`refContext`**

An empty string is used for this parameter when the refString parameter is specified as "ObjectName.AttributeName". When using a relative reference (like "MyArea.ScanState" or "MyPlatform.CPULoad") in the refString parameter, the refContext parameter must be the Tagname property of the object. The refContext parameter can be empty if the refString parameter contains an absolute path.

**`suspended`**

true: suspend attribute.

false: Activate attribute.

**Returns**

CMxIndirect

**Remarks**

After the BindTo() operation, access the value of the Indirect only if the Indirect's StatusOfLastRead.success = = -1 and StatusOfLastRead.Category = = MxStatusCategory.MxCategoryOk

### BindToWriteOnly Method (string, string)

Provides a method to create an Indirect (CMxIndirectWriteOnly) for write-only access to Attributes of other Objects.

**Syntax**

```csharp
public CMxIndirectWriteOnly BindToWriteOnly(
string refString,
string refContext
);
```

**Parameters**

**`refString`**

The reference of the attribute of another object in "ObjectName.AttributeName" format.

**`refContext`**

An empty string is used for this parameter when the refString parameter is specified as "ObjectName.AttributeName". When using a relative reference (like "MyArea.ScanState" or "MyPlatform.CPULoad") in the refString parameter, the refContext parameter must be the Tagname property of the object. The refContext parameter can be empty if the refString parameter contains an absolute path.

**Example:**

```csharp
CMxIndirectWriteOnly mxIndirect = BindToWriteOnly("MyArea.ScanState", Tagname);
```

**Returns**

CMxIndirectWriteOnly

### BindToWriteOnly Method (string, string, bool)

Provides a method to create an Indirect (CMxIndirectWriteOnly) for write-only access to Attributes of other Objects.

**Syntax**

```csharp
public CMxIndirectWriteOnly BindToWriteOnly(
string refString,
string refContext,
bool suspended
);
```

**Parameters**

**`refString`**

The reference of the attribute of another object in "ObjectName.AttributeName" format.

**`refContext`**

An empty string is used for this parameter.

**`suspended`**

true: suspend attribute.

false: Activate attribute.

**Returns**

CMxIndirectWriteOnly

### CheckpointDynamicAttributeData Method

Provides a method to store the values of all dynamic attributes created at runtime, that were not explicitly excluded from failover. This method should be called immediately after a dynamic attribute value is changed.

**Syntax**

```csharp
public bool CheckpointDynamicAttributeData();
```

**Returns**

bool

### DeleteAttribute Method (string)

Provides a method to delete a Dynamic Attribute by Attribute Name.

**Syntax**

```csharp
public void DeleteAttribute(
string name
);
```

**Parameters**

**`name`**

Name of the Dynamic attribute.

### DeleteAttribute Method (string, bool)

Provides a detailed method to delete a Dynamic Attribute and remove it from the failover data, if needed.

**Syntax**

```csharp
public void DeleteAttribute(
string name,
bool failover
);
```

**Parameters**

**`name`**

Name of the Dynamic attribute.

**`failover`**

true: remove the attribute from failover.

### GetAttributeName Method (short, short, string)

Provides a method to get the name of an attribute by ID and primitive ID.

**Syntax**

```csharp
public bool GetAttributeName(
short attributeId,
short primitiveId,
out string name
);
```

**Parameters**

**`attributeId`**

The attribute ID.

**`PrimitiveId`**

The primitive ID.

**`name`**

Fills the name parameter with the attribute external name.

**Returns**

bool

true: access to attribute name is success.

false: fails if the user tries to access a non-existing attribute.

### GetAttributeProperties Method (string, MxDataType, MxSecurityClassification, MxAttributeCategory, MxPropertyLockedEnum, int, int, int, int, int, int, int, int, int)

Provides a method to get all the properties of dynamic attribute by attribute name.

**Syntax**

```csharp
public bool GetAttributeProperties(
string fullName,
out MxDataType dataType,
out MxSecurityClassification secClass,
out MxAttributeCategory category,
out MxPropertyLockedEnum locked,
out int hasRtHandler,
out int hasQuality,
out int hasTimestamp,
out int isShared,
out int isArray,
out int isDynamic,
out int isSubscribed,
out int isCheckpointed,
out int hasTypeChanged
);
```

**Parameters**

Refer to the section GetAttributeProperties Method Parameters and Return Value.

**Returns**

Refer to the section GetAttributeProperties Method Parameters and Return Value.

### GetAttributeProperties Method (short, short, MxDataType, MxSecurityClassification, MxAttributeCategory, MxPropertyLockedEnum, int, int, int, int, int, int, int, int, int)

Provides a method to get all the properties of dynamic attribute by Attribute ID and Primitive ID.

**Syntax**

```csharp
public bool GetAttributeProperties(
short attributeId,
short primitiveId,
out MxDataType dataType,
out MxSecurityClassification secClass,
out MxAttributeCategory category,
out MxPropertyLockedEnum locked,
out int hasRtHandler,
out int hasQuality,
out int hasTimestamp,
out int isShared,
out int isArray,
out int isDynamic,
out int isSubscribed,
out int isCheckpointed,
out int hasTypeChanged
);
```

**Parameters**

Refer to the section GetAttributeProperties Method Parameters and Return Value.

**Returns**

Refer to the section GetAttributeProperties Method Parameters and Return Value.

### GetAttributeProperties Method Parameters and Return Value

**Parameters**

**`fullName`**

External Name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`dataType`**

The out parameter which contains the Datatype of the attribute.

**`secClass`**

The out parameter which contains the Security Classification of the attribute.

**`category`**

The out parameter which contains the Category of the attribute.

**`locked`**

The out parameter which contains the lock status of the attribute.

**`hasRtHandler`**

The out parameter which specifies whether the attribute has runtime set handler.

1: if attribute has runtime set handler.

0: if attribute doesn't have runtime set handler.

**`hasQuality`**

The out parameter which specifies whether the attribute supports quality.

1: if attribute supports quality.

0: if attribute doesn't supports quality.

**`hasTimestamp`**

The out parameter which specifies whether the attribute has timestamp.

1: if attribute has timestamp.

0:if attribute doesn't have timestamp.

**`isShared`**

The out parameter which specifies whether the attribute is shared

1: if attribute is shared type.

0: if attribute is non-shared type.

**`isArray`**

The out parameter which specifies whether the attribute is array type.

1: if attribute is array type.

0: if attribute is non-array type.

**`isDynamic`**

The out parameter which specifies whether the attribute is dynamic.

1: if attribute is dynamic.

0: if attribute is static.

**`isSubscribed`**

The out parameter which specifies whether the attribute is subscribed.

1: if attribute is subscribed.

0: if attribute is not subscribed.

**`isCheckpointed`**

The out parameter which specifies whether the attribute has check point support.

1: if attribute has checkpointed.

0: if attribute in not checkpointed.

**`hasTypeChanged`**

The out parameter which specifies whether the attribute type is changed.

1: if attribute datatype is changed.

0: if attribute datatype is not changed.

**Returns**

bool

true: if the attribute is exits and access to the attribute properties is successful.

false: if the user tries to access a non-existing attribute.

### GetBoolean Method (string, bool)

Provides a method to get the value of a Boolean attribute by its external name.

**Syntax**

```csharp
public bool GetBoolean(
string fullName,
out bool value
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (short, short, bool)

Provides a method to get the value of a Boolean attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetBoolean(
short attributeId,
short primitiveId,
out bool value
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (string, int, bool)

Provides a method to get the value of a Boolean array element by its external name and index.

**Syntax**

```csharp
public bool GetBoolean(
string fullName,
int index,
out bool value
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (string, bool, CMxDataQuality)

Provides a method to get the value and quality of a Boolean attribute by its external name.

**Syntax**

```csharp
public bool GetBoolean(
string fullName,
out bool value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (short, short, int, bool)

Provides a method to get the value of a Boolean array element by its ID, Primitive ID, and index.

**Syntax**

```csharp
public bool GetBoolean(
short attributeId,
short primitiveId,
int index,
out bool value
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (short, short, bool, CMxDataQuality)

Provides a method to get the value and quality of a Boolean attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetBoolean(
short attributeId,
short primitiveId,
out bool value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (string, bool, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a Boolean attribute by its external name.

**Syntax**

```csharp
public bool GetBoolean(
string fullName,
out bool value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value

### GetBoolean Method (short, short, bool, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a Boolean attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetBoolean(
short attributeId,
short primitiveId,
out bool value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetBoolean Method Parameters and Return Value.

**Returns**

Refer to the section GetBoolean Method Parameters and Return Value.

### GetBoolean Method Parameters and Return Value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The out parameter which contains the value of the Boolean attribute.

**`Index`**

The Boolean array index.

**`quality`**

The out parameter contains the quality property of Boolean attribute.

**`time`**

The out parameter contains the Date and Time associated with the Boolean attribute.

**Returns**

bool

true: if the Boolean attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetBooleanArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a Boolean array attribute by its external name.

**Syntax**

```csharp
public bool GetBooleanArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of Boolean attribute.

**Returns**

bool

true: if the Boolean attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetBooleanArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a Boolean array attribute by its ID and primitive ID.

**Syntax**

```csharp
public bool GetBooleanArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of Boolean attribute.

**Returns**

bool

true: if the Boolean attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetCustomEnum Method (string, short)

Provides a method to get a custom enum ordinal by its external name.

**Syntax**

```csharp
public bool GetCustomEnum(
string fullName,
out short value
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (short, short, short)

Provides a method to get a custom enum ordinal by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetCustomEnum(
short attributeId,
short primitiveId,
out short value
);
```

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (string, int, short)

Provides a method to get a custom enum array element ordinal by its external name and index.

**Syntax**

```csharp
public bool GetCustomEnum(
string fullName,
int index,
out short value
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (string, short, CMxDataQuality)

Provides a method to get a custom enum ordinal and quality by its external name.

**Syntax**

```csharp
public bool GetCustomEnum(
string fullName,
out short value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (short, short, int, short)

Provides a method to get a custom enum array element ordinal by its ID, Primitive ID and index.

**Syntax**

```csharp
public bool GetCustomEnum(
short attributeId,
short primitiveId,
int index,
out short value
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (short, short, short, CMxDataQuality)

Provides a method to get a custom enum ordinal and quality by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetCustomEnum(
short attributeId,
short primitiveId,
out short value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (string, short, DateTime, CMxDataQuality)

Provides a method to get a custom enum ordinal, time, and quality by its external name.

**Syntax**

```csharp
public bool GetCustomEnum(
string fullName,
out short value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value

### GetCustomEnum Method (short, short, short, DateTime, CMxDataQuality)

Provides a method to get a custom enum ordinal, time, and quality by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetCustomEnum(
short attributeId,
short primitiveId,
out short value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomEnum Method Parameters and Return value.

**Returns**

Refer to the section GetCustomEnum Method Parameters and Return value.

### GetCustomEnum Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The out parameter which contains the ordinal value of the CustomEnum attribute.

**`Index`**

The CustomEnum array index.

**`quality`**

The quality property of CustomEnum attribute.

**`time`**

The out parameter contains the Date and Time associated with the CustomEnum attribute.

**Returns**

bool

true: if the CustomEnum attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetCustomStruct Method (string, MxCustomStruct)

Provides a method to get the value of a CustomStruct attribute by its external name.

**Syntax**

```csharp
public bool GetCustomStruct(
string fullName,
out MxCustomStruct value
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (short, short, MxCustomStruct)

Provides a method to get the value of a CustomStruct attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetCustomStruct(
short attributeId,
short primitiveId,
out MxCustomStruct value
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (string, int, MxCustomStruct)

Provides a method to get the value of a CustomStruct array element by its external name and index.

**Syntax**

```csharp
public bool GetCustomStruct(
string fullName,
int index,
out MxCustomStruct value
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (string, MxCustomStruct, CMxDataQuality)

Provides a method to get the value and quality of a CustomStruct attribute by its external name.

**Syntax**

```csharp
public bool GetCustomStruct(
string fullName,
out MxCustomStruct value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (short, short, int, MxCustomStruct)

Provides a method to get the value of a CustomStruct array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetCustomStruct(
short attributeId,
short primitiveId,
int index,
out MxCustomStruct value
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (short, short, MxCustomStruct, CMxDataQuality)

Provides a method to get the value and quality of a CustomStruct attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetCustomStruct(
short attributeId,
short primitiveId,
out MxCustomStruct value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (string, MxCustomStruct, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a CustomStruct attribute by its external name.

**Syntax**

```csharp
public bool GetCustomStruct(
string fullName,
out MxCustomStruct value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method (short, short, MxCustomStruct, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a CustomStruct attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetCustomStruct(
short attributeId,
short primitiveId,
out MxCustomStruct value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetCustomStruct Method Parameters and Return value.

### GetCustomStruct Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of a CustomStruct attribute.

**`Index`**

The CustomStruct array index.

**`quality`**

The out parameter contains the quality property of CustomStruct attribute.

**`time`**

The out parameter contains the Date and time associated with the CustomStruct attribute.

**Returns**

bool

true: if the CustomStruct attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetCustomEnumArrayQ Method (string, CMxDataQuality)

Provides a method to get a custom enum array quality by its external name.

**Syntax**

```csharp
public bool GetCustomEnumArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of CustomEnum attribute.

**Returns**

bool

true: if the CustomEnum attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetCustomEnumArrayQ Method (short, short, CMxDataQuality)

Provides a method to get a custom enum array quality by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetCustomEnumArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**Returns**

bool

The out parameter contains the quality property of CustomEnum attribute.

### GetCustomStructArrayQ Method (string, CMxDataQuality)

Provides a method to get a custom struct array quality by its external name.

**Syntax**

```csharp
public bool GetCustomStructArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of CustomStruct array attribute.

**Returns**

bool

true: if the CustomStruct array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetCustomStructArrayQ Method (short, short, CMxDataQuality)

Provides a method to get a custom struct array quality by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetCustomStructArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of CustomStruct array attribute.

**Returns**

bool

true: if the CustomStruct array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetDataFromFailoverField Method

Provides a method to get the data stored in the Failover Attributes as a C# object. The object developer is not expected to typically use this method.

**Syntax**

```csharp
public object GetDataFromFailoverField();
```

**Returns**

object

### GetDefaultTimeStamp Method

Provides a method to get the object startup time.

**Syntax**

```csharp
public bool GetDefaultTimeStamp(
out DateTime timestamp
);
```

**Parameters**

**`timestamp`**

The out parameter contains the Object startup time.

**Returns**

bool

true: If the object startup time accessing is successful.

false: If the object startup time accessing failed.

### GetDouble Method (string, double)

Provide a method to get the value of a Double attribute by its external name.

**Syntax**

```csharp
public bool GetDouble(
string fullName,
out double value
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (short, short, double)

Provides a method to get the value of a Double attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetDouble(
short attributeId,
short primitiveId,
out double value
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (string, int, double)

Provides a method to get the value of a Double array element by its external name and index.

**Syntax**

```csharp
public bool GetDouble(
string fullName,
int index,
out double value
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (string, double, CMxDataQuality)

Provides a method to get the value and quality of a Double attribute by its external name.

**Syntax**

```csharp
public bool GetDouble(
string fullName,
out double value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (short, short, int, double)

Provides a method to get the value of a Double array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetDouble(
short attributeId,
short primitiveId,
int index,
out double value
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (short, short, double, CMxDataQuality)

Provides a method to get the value and quality of a Double attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetDouble(
short attributeId,
short primitiveId,
out double value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (string, double, DateTime, CMxDataQuality)

Provides a method to get the value,time and quality of a Double attribute by its external name.

**Syntax**

```csharp
public bool GetDouble(
string fullName,
out double value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method (short, short, double, DateTime, CMxDataQuality)

Provides a method to get the value,time and quality of a Double attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetDouble(
short attributeId,
short primitiveId,
out double value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetDouble Method Parameters and Return value.

### GetDouble Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of a Double attribute.

**`Index`**

The Double array index.

**`quality`**

The out parameter contains the quality property of Double attribute.

**`time`**

The out parameter contains the Date and Time associated with the Double attribute.

**Returns**

bool

true: if the Double attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetDoubleArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a double array attribute by its external name.

**Syntax**

```csharp
public bool GetDoubleArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of Double array attribute.

**Returns**

bool

true: if the Double array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetDoubleArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a double array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetDoubleArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of Double array attribute.

**Returns**

bool

true: if the Double array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetElapsedTime Method (string, TimeSpan)

Provides a method to get the value of an ElapsedTime attribute by its external name.

**Syntax**

```csharp
public bool GetElapsedTime(
string fullName,
out TimeSpan value
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (short, short, TimeSpan)

Provides a method to get the value of an ElapsedTime attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetElapsedTime(
short attributeId,
short primitiveId,
out TimeSpan value
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (string, int, TimeSpan)

Provides a method to get the value of an ElapsedTime array element by its external name and index.

**Syntax**

```csharp
public bool GetElapsedTime(
string fullName,
int index,
out TimeSpan value
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (string, TimeSpan, CMxDataQuality)

Provides a method to get the value and quality of an ElapsedTime attribute by its external name.

**Syntax**

```csharp
public bool GetElapsedTime(
string fullName,
out TimeSpan value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (short, short, int, TimeSpan)

Provides a method to get the value of an ElapsedTime array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetElapsedTime(
short attributeId,
short primitiveId,
int index,
out TimeSpan value
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (short, short, TimeSpan, CMxDataQuality)

Provides a method to get the value and quality of an ElapsedTime attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetElapsedTime(
short attributeId,
short primitiveId,
out TimeSpan value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (string, TimeSpan, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of an ElapsedTime attribute by its external name.

**Syntax**

```csharp
public bool GetElapsedTime(
string fullName,
out TimeSpan value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method (short, short, TimeSpan, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of an ElapsedTime attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetElapsedTime(
short attributeId,
short primitiveId,
out TimeSpan value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetElapsedTime Method Parameters and Return value.

### GetElapsedTime Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of an ElapsedTime attribute.

**`Index`**

The ElapsedTime array index.

**`quality`**

The out parameter contains the quality property of an ElapsedTime attribute.

**`time`**

The out parameter contains the Date and time associated with the ElapsedTime attribute.

**Returns**

bool

true: if the ElapsedTime attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetElapsedTimeArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of an ElapsedTime array attribute by its external name.

**Syntax**

```csharp
public bool GetElapsedTimeArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of ElapsedTime array attribute.

**Returns**

bool

true: if ElapsedTime array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetElapsedTimeArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of an ElapsedTime array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetElapsedTimeArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of ElapsedTime array attribute.

**Returns**

bool

true: if ElapsedTime array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetFloat Method (string, float)

Provides a method to get the value of a float attribute by its external name.

**Syntax**

```csharp
public bool Float(
string fullName,
out float value
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (short, short, float)

Provides a method to get the value of a float attribute by its id and primitive id.

**Syntax**

```csharp
public bool Float(
short attributeId,
short primitiveId,
out float value
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (string, int, float)

Provides a method to get the value of a float array element by its external name and index.

**Syntax**

```csharp
public bool GetFloat(
string fullName,
int index,
out float value
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (string, float, CMxDataQuality)

Provides a method to get the value and quality of a float attribute by its external name.

**Syntax**

```csharp
public bool GetFloat(
string fullName,
out float value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (short, short, int, float)

Provides a method to get the value of a float array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetFloat(
short attributeId,
short primitiveId,
int index,
out float value
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (short, short, float, CMxDataQuality)

Provides a method to get the value and quality of a float attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetFloat(
short attributeId,
short primitiveId,
out float value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (string, float, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a float attribute by its external name.

**Syntax**

```csharp
public bool GetFloat(
string fullName,
out float value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method (short, short, float, DateTime, CMxDataQuality)

Provides a method to get the value,time and quality of a float attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetFloat(
short attributeId,
short primitiveId,
out float value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetFloat Method Parameters and Return value.

### GetFloat Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of a float attribute.

**`Index`**

The Float array index.

**`quality`**

The out parameter contains the quality property of Float attribute.

**`time`**

The out parameter contains the Date and Time associated with the Float attribute.

**Returns**

bool

true: if the Float attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetFloatArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of Float array attribute by its external name.

**Syntax**

```csharp
public bool GetFloatArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of Float array attribute.

**Returns**

bool

true: if the Float array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetFloatArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a Float array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetFloatArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of Float array attribute.

**Returns**

bool

true: if the Float array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetInteger Method (string, int)

Provides a method to get the value of an integer attribute by its external name.

**Syntax**

```csharp
public bool GetInteger(
string fullName,
out int value
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (short, short, int)

Provides a method to get the value of an integer attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetInteger(
short attributeId,
short primitiveId,
out int value
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (string, int, int)

Provides a method to get the value of an integer array element by its external name and index.

**Syntax**

```csharp
public bool GetInteger(
string fullName,
int index,
out int value
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (string, int, CMxDataQuality)

Provides a method to get the value and quality of an integer attribute by its external name.

**Syntax**

```csharp
public bool GetInteger(
string fullName,
out int value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (short, short, int, int)

Provides a method to get the value of an integer array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetInteger(
short attributeId,
short primitiveId,
int index,
out int value
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (short, short, int, CMxDataQuality)

Provides a method to get the value and quality of an integer attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetInteger(
short attributeId,
short primitiveId,
out int value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (string, int, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of an integer attribute by its external name.

**Syntax**

```csharp
public bool GetInteger(
string fullName,
out int value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method (short, short, int, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of an integer attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetInteger(
short attributeId,
short primitiveId,
out int value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetInteger Method Parameters and Return value.

### GetInteger Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of an integer attribute.

**`Index`**

The Integer array index.

**`quality`**

The out parameter contains the quality property of Integer attribute.

**`time`**

The out parameter contains the Date and Time associated with the Integer attribute.

**Returns**

bool

true: if the Integer attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetIntegerArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of an Integer array attribute by its external name.

**Syntax**

```csharp
public bool GetIntegerArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of Integer array attribute.

**Returns**

boo

true: if the Integer array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetIntegerArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a Integer array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetIntegerArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of Integer array attribute.

**Returns**

bool

true: if the Integer array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetLockStatus Method (string, MxPropertyLockedEnum)

Provides a method to get the LockStatus of an attribute by its external name.

**Syntax**

```csharp
public bool GetLockStatus(
string fullName,
out MxPropertyLockedEnum lockStatus
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`lockStatus`**

The out parameter contains the LockStatus property of an attribute.

**Returns**

bool

true: if the attribute LockStatus accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetLockStatus Method (short, short, MxPropertyLockedEnum)

Provides a method to get the LockStatus of an attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetLockStatus(
short attributeId,
short primitiveId,
out MxPropertyLockedEnum lockStatus
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`lockStatus`**

The out parameter contains the LockStatus property of an attribute.

**Returns**

bool

true: if the attribute LockStatus accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetMxDataType Method (string, MxDataType)

Provides a method to get the value of a MxDataType attribute by its external name.

**Syntax**

```csharp
public bool GetMxDataType(
string fullName,
out MxDataType value
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (short, short, MxDataType)

Provides a method to get the value of a MxDataType attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetMxDataType(
short attributeId,
short primitiveId,
out MxDataType value
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (string, int, MxDataType)

Provides a method to get the value of a MxDataType array element by its external name and index.

**Syntax**

```csharp
public bool GetMxDataType(
string fullName,
int index,
out MxDataType value
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (string, MxDataType, CMxDataQuality)

Provides a method to get the value and quality of a MxDataType attribute by its external name.

**Syntax**

```csharp
public bool GetMxDataType(
string fullName,
out MxDataType value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (short, short, int, MxDataType)

Provides a method to get the value of a MxDataType array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetMxDataType(
short attributeId,
short primitiveId,
int index,
out MxDataType value
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (short, short, MxDataType, CMxDataQuality)

Provides a method to get the value and quality of a MxDataType attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetMxDataType(
short attributeId,
short primitiveId,
out MxDataType value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (string, MxDataType, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a MxDataType attribute by its external name.

**Syntax**

```csharp
public bool GetMxDataType(
string fullName,
out MxDataType value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method (short, short, MxDataType, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a MxDataType attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetMxDataType(
short attributeId,
short primitiveId,
out MxDataType value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxDataType Method Parameters and Return value.

### GetMxDataType Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of an MxDataType attribute.

**`Index`**

The MxDataType array index.

**`quality`**

The out parameter contains the quality property of MxDataType attribute.

**`time`**

The out parameter contains the Date and time associated with the MxDataType attribute.

**Returns**

bool

true: if the MxDataType attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetMxDataTypeArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a MxDataType array attribute by its external name.

**Syntax**

```csharp
public bool GetMxDataTypeArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of MxDataType array attribute.

**Returns**

bool

true: if the MxDataType array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetMxDataTypeArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a MxDataType array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetMxDataTypeArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of MxDataType array attribute.

**Returns**

bool

true: if MxDataType array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetMxStatus Method (string, MxStatus)

Provides a method to get the value of a MxStatus attribute by its external name.

**Syntax**

```csharp
public bool GetMxStatus(
string fullName,
out MxStatus value
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value.

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value.

### GetMxStatus Method (short, short, MxStatus)

Provides a method to get the value of a MxStatus attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetMxStatus(
short attributeId,
short primitiveId,
out MxStatus value
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value.

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value.

### GetMxStatus Method (string, int, MxStatus)

Provides a method to get the value of a MxStatus array element by its external name and index.

**Syntax**

```csharp
public bool GetMxStatus(
string fullName,
int index,
out MxStatus value
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value.

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value.

### GetMxStatus Method (string, MxStatus, CMxDataQuality)

Provides a method to get the value and quality of a MxStatus attribute by its external name.

**Syntax**

```csharp
public bool GetMxStatus(
string fullName,
out MxStatus value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value

### GetMxStatus Method (short, short, int, MxStatus)

Provides a method to get the value of a MxStatus array element by its ID, Primitive ID and index.

**Syntax**

```csharp
public bool GetMxStatus(
short attributeId,
short primitiveId,
int index,
out MxStatus value
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value

### GetMxStatus Method (short, short, MxStatus, CMxDataQuality)

Provides a method to get the value and quality of a MxStatus array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetMxStatus(
short attributeId,
short primitiveId,
out MxStatus value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value

### GetMxStatus Method (string, MxStatus, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a MxStatus attribute by external name.

**Syntax**

```csharp
public bool GetMxStatus(
string fullName,
out MxStatus value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value

### GetMxStatus Method (short, short, MxStatus, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a MxStatus attribute by its ID and primitive ID.

**Syntax**

```csharp
public bool GetMxStatus(
short attributeId,
short primitiveId,
out MxStatus value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetMxStatus Method Parameters and Return value.

**Returns**

Refer to the section GetMxStatus Method Parameters and Return value.

### GetMxStatus Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The out parameter which contains the value of the MxStatus attribute.

**`Index`**

The MxStatus array index.

**`quality`**

The quality property of MxStatus attribute.

**`time`**

The out parameter contains the Date and Time associated with the MxStatus attribute.

**Returns**

bool

true: if the MxStatus attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetMxStatusArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a MxStatus array attribute by its external name.

**Syntax**

```csharp
public bool GetMxStatusArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of the MxStatus array attribute.

**Returns**

bool

true: if the MxStatus array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetMxStatusArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a MxStatus array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetMxStatusArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of MxStatus array attribute.

**Returns**

bool

true: if the MxStatus array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetNormalChildID Method

Provides a method to access the ID of a non-virtual Child Primitive by its parent primitive ID and primitive internal name.

**Syntax**

```csharp
public short GetNormalChildID(
short parentPrimID,
string primInternalName
);
```

**Parameters**

**`parentPrimID`**

The parent primitive ID.

**`primInternalName`**

The primitive internal name.

**Returns**

bool

### GetNumElementsEx Method (string, int)

Provides a method to return the number of elements of an array attribute by its external name.

**Syntax**

```csharp
public bool GetNumElementsEx(
string fullName,
out int numElements
);
```

**Parameters**

**`fullName`**

The Name of the array attribute.

**`numElements`**

The out parameter contains the number of elements in the array.

**Returns**

bool

true: if the accessing of number of elements in array elements is successful.

false: if the user tries to access a non-existing attribute.

### GetNumElementsEx Method (short, short, int)

Provides a method to return the number of elements of an array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetNumElementsEx(
short attributeId,
short primitiveId,
out int numElements
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`numElements`**

The out parameter contains the number of elements in the array.

**Returns**

bool

true: if the accessing of number of elements in an array is successful.

false: if the user tries to access a non-existing attribute.

### GetPrimitiveIds Method

Provides a method to return ID's of the primitives in an object.

**Syntax**

```csharp
public bool GetPrimitiveIds(out short[] primitiveIds);
```

**Parameters**

**`primitiveIds`**

The array contains all the primitive IDs.

**Returns**

bool

### GetPrimitiveInfo Method

Provides an implementation of IPrimitiveDeployment member returning the file that contains the aaDEF as a resource and the ID of the resource in the file.

**Syntax**

```csharp
public void GetPrimitiveInfo(
ref string pFilename,
ref int pResourceId
);
```

**Parameters**

**`pFilename`**

The file name.

**`pResourceId`**

The resource ID.

### GetPrimitiveRuntimeSite2 Method

Provides access to RuntimeSite2 interface of a primitive by ID.

**Syntax**

```csharp
public IPrimitiveRuntimeSite2 GetPrimitiveRuntimeSite2(short _primID);
```

**Parameters**

**`_primID`**

The primitive.

**Returns**

IPrimitiveRuntimeSite2

### GetQ Method (string)

Provides a method to get the quality of an attribute by name.

**Syntax**

```csharp
public CMxDataQuality GetQ(string fullName);
```

**Parameters**

**`fullName`**

External Name of the attribute.

**Returns**

CMxDataQuality

### GetQ Method (short, short)

Provides a method to get the quality of an attribute by ID and Primitive ID.

**Syntax**

```csharp
public CMxDataQuality GetQ(
short attributeId,
short primitiveId
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**Returns**

CMxDataQuality

### GetQuality Method (string, MxDataType, CMxDataQuality)

Provides a method to get the quality of an attribute by its type and name.

**Syntax**

```csharp
public bool GetQuality(
string fullName,
MxDataType dataType,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External Name of the attribute.

**`dataType`**

The Datatype of an attribute. The supported datatype are:

MxBoolean

MxInteger

MxFloat

MxDouble

MxString

MxTime

MxElapsedTime

MxReferenceType

MxStatusType

MxDataTypeEnum

MxQualifiedEnum

MxQualifiedStruct

**`quality`**

The out parameter contains the quality property of an attribute.

**Returns**

bool

true: if attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetQuality Method (short, short, MxDataType, CMxDataQuality)

Provides a method to get the quality of an attribute by its type, ID, and Primitive ID.

**Syntax**

```csharp
public bool GetQuality(
short attributeId,
short primitiveId,
MxDataType dataType,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`dataType`**

The Datatype of an attribute. The supported datatype are:

MxBoolean

MxInteger

MxFloat

MxDouble

MxString

MxTime

MxElapsedTime

MxReferenceType

MxStatusType

MxDataTypeEnum

MxQualifiedEnum

MxQualifiedStruct

**`quality`**

The out parameter contains the quality property of an attribute.

**Returns**

bool

true: if attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetReference Method (string, IMxReference)

Provides a method to access the reference attribute by its external name.

**Syntax**

```csharp
public bool GetReference(
string fullName,
out IMxReference value
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (short, short, IMxReference)

Provides a method to access the reference attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetReference(
short attributeId,
short primitiveId,
out IMxReference value
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (string, int, IMxReference)

Provides a method to access the reference array element by its external name and index.

**Syntax**

```csharp
public bool GetReference(
string fullName,
int index,
out IMxReference value
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (string, IMxReference, CMxDataQuality)

Provides a method to access the reference attribute and quality by its external name.

**Syntax**

```csharp
public bool GetReference(
string fullName,
out IMxReference value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (short, short, int, IMxReference)

Provides a method to access the reference array element by its ID, Primitive ID, and index.

**Syntax**

```csharp
public bool GetReference(
short attributeId,
short primitiveId,
int index,
out IMxReference value
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (short, short, IMxReference, CMxDataQuality)

Provides a method to access the reference attribute and quality by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetReference(
short attributeId,
short primitiveId,
out IMxReference value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (string, IMxReference, DateTime, CMxDataQuality)

Provides a method to access the reference attribute, its quality and time by external name.

**Syntax**

```csharp
public bool GetReference(
string fullName,
out IMxReference value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method (short, short, IMxReference, DateTime, CMxDataQuality)

Provides a method to access the reference attribute, its quality and time by ID and Primitive ID.

**Syntax**

```csharp
public bool GetReference(
short attributeId,
short primitiveId,
out IMxReference value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetReference Method Parameters and Return value.

**Returns**

Refer to the section GetReference Method Parameters and Return value.

### GetReference Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The out parameter which contains the value of the Reference attribute.

**`Index`**

The Reference attribute array index.

**`quality`**

The quality property of Reference attribute.

**`time`**

The out parameter contains the Date and Time associated with the Reference attribute.

**Returns**

bool

true: if the Reference attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetReferenceArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a Reference array attribute by its external name.

**Syntax**

```csharp
public bool GetReferenceArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of an attribute.

**`quality`**

The out parameter contains the quality property of Reference attribute.

**Returns**

bool

true: if the Reference attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetReferenceArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a Reference array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetReferenceArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of Reference attribute.

**Returns**

bool

true: if the Reference attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetScanTime Method

Provides a method to access to the current scan time.

**Syntax**

```csharp
public DateTime GetScanTime();
```

**Returns**

DateTime

### GetScanTime Method (short)

Provides a method to access to the current scan time with time zone offset.

**Syntax**

```csharp
public DateTime GetScanTime(
out short offset
);
```

**Parameters**

**`offset`**

The time zone offset.

**Returns**

DateTime

### GetStatusDescription Method

Provides a method to get the string associated with an error code.

**Syntax**

```csharp
public string GetStatusDescription(
short shDetailedErrorCode
);
```

**Parameters**

**`shDetailedErrorCode`**

The error code.

**Returns**

string

The string value corresponding to the error code.

### GetString Method (string, string)

Provides a method to get the value of string attribute by its external name.

**Syntax**

```csharp
public bool GetString(
string fullName,
out string value
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value

**Returns**

Refer to the section GetString Method Parameters and Return value

### GetString Method (short, short, string)

Provides a method to get the value of string attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetString(
short attributeId,
short primitiveId,
out string value
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value

**Returns**

Refer to the section GetString Method Parameters and Return value

### GetString Method (string, int, string)

Provides a method to get the value of string array element by its external name and index.

**Syntax**

```csharp
public bool GetString(
string fullName,
int index,
out string value
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value.

**Returns**

Refer to the section GetString Method Parameters and Return value.

### GetString Method (string, string, CMxDataQuality)

Provides a method to get the value and quality of string attribute by its external name.

**Syntax**

```csharp
public bool GetString(
string fullName,
out string value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value.

**Returns**

Refer to the section GetString Method Parameters and Return value.

### GetString Method (short, short, int, string)

Provides a method to get the value of string array element by its ID, Primitive ID, and index.

**Syntax**

```csharp
public bool GetString(
short attributeId,
short primitiveId,
int index,
out string value
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value.

**Returns**

Refer to the section GetString Method Parameters and Return value.

### GetString Method (short, short, string, CMxDataQuality)

Provides a method to get the value and quality of string attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetString(
short attributeId,
short primitiveId,
out string value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value.

**Returns**

Refer to the section GetString Method Parameters and Return value.

### GetString Method (string, string, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of string attribute by its external name.

**Syntax**

```csharp
public bool GetString(
string fullName,
out string value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value.

**Returns**

Refer to the section GetString Method Parameters and Return value.

### GetString Method (short, short, string, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of string attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetString(
short attributeId,
short primitiveId,
out string value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetString Method Parameters and Return value

**Returns**

Refer to the section GetString Method Parameters and Return value

### GetString Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The out parameter which contains the value of the string attribute.

**`Index`**

The string array index.

**`quality`**

The quality property of string attribute.

**`time`**

The out parameter contains the Date and Time associated with the string attribute.

**Returns**

bool

true: if the string attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetStringArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a string array attribute by its external name.

**Syntax**

```csharp
public bool GetStringArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of string array attribute.

**Returns**

bool

true: if the string array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetStringArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a string array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetStringArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of string array attribute.

**Returns**

bool

true: if the string array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetTime Method (string, DateTime)

Provides a method to get the value of a time attribute by its external name.

**Syntax**

```csharp
public bool GetTime(
string fullName,
out DateTime value
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (short, short, DateTime)

Provides a method to get the value of a time attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetTime(
short attributeId,
short primitiveId,
out DateTime value
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (string, int, DateTime)

Provides a method to get the value of a time array element by its external name and index.

**Syntax**

```csharp
public bool GetTime(
string fullName,
int index,
out DateTime value
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (string, DateTime, CMxDataQuality)

Provides a method to get the value and quality of a time attribute by its external name.

**Syntax**

```csharp
public bool GetTime(
string fullName,
out DateTime value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (short, short, int, DateTime)

Provides a method to get the value of a time array element by its id, primitive id, and index.

**Syntax**

```csharp
public bool GetTime(
short attributeId,
short primitiveId,
int index,
out DateTime value
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (short, short, DateTime, CMxDataQuality)

Provides a method to get the value and quality of a time attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetTime(
short attributeId,
short primitiveId,
out DateTime value,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (string, DateTime, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a time attribute by its external name.

**Syntax**

```csharp
public bool GetTime(
string fullName,
out DateTime value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method (short, short, DateTime, DateTime, CMxDataQuality)

Provides a method to get the value, time, and quality of a time attribute by its id and primitive id.

**Syntax**

```csharp
public bool GetTime(
short attributeId,
short primitiveId,
out DateTime value,
out DateTime time,
out CMxDataQuality quality
);
```

**Parameters**

Refer to the section GetTime Method Parameters and Return value.

### GetTime Method Parameters and Return value

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute id.

**`primitiveId`**

Primitive id of an attribute.

**`Value`**

The out parameter which contains the value of a time attribute.

**`Index`**

The DateTime array index.

**`quality`**

The out parameter contains the quality property of time attribute.

**`time`**

The out parameter contains the Date and Time associated with the time attribute.

**Returns**

bool

true: if the time attribute accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetTimeArrayQ Method (string, CMxDataQuality)

Provides a method to get the quality of a Time array attribute by its external name.

**Syntax**

```csharp
public bool GetTimeArrayQ(
string fullName,
out CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The out parameter contains the quality property of the Time array attribute.

**Returns**

bool

true: if the Time array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetTimeArrayQ Method (short, short, CMxDataQuality)

Provides a method to get the quality of a Time array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool GetTimeArrayQ(
short attributeId,
short primitiveId,
out CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The out parameter contains the quality property of Time array attribute.

**Returns**

bool

true: if the Time array attribute quality accessing is successful.

false: if the user tries to access a non-existing attribute.

### GetTimeStamp Method (string, MxDataType, DateTime)

Provides a method to get the time of an attribute by name.

**Syntax**

```csharp
public bool GetTimeStamp(
string fullName,
MxDataType dataType,
out DateTime time
);
```

**Parameters**

**`fullName`**

External name of attribute.

**`dataType`**

Datatype of an attribute.

**`time`**

The out parameter contains the date and time of an attribute.

**Returns**

bool

true: if accessing the Date and Time of an attribute is successful.

false: if the user tries to access a non-existing attribute.

### GetTimeStamp Method (short, short, MxdataType, DateTime)

Provides a method to get the time of an attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool GetTimeStamp(
short attributeId,
short primitiveId,
MxDataType dataType,
out DateTime time
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`dataType`**

Datatype of an attribute.

**`time`**

The out parameter contains the date and time of an attribute.

**Returns**

bool

true: if accessing the Date and Time of an attribute is successful.

false: if the user tries to access a non-existing attribute.

### GetType Method (string, MxDataType, int)

Provides a method to get the type of an attribute by name.

**Syntax**

```csharp
public bool GetType(
string fullName,
out MxDataType dataType,
out int isArray
);
```

**Parameters**

**`fullName`**

External name of an attribute.

**`dataType`**

The out parameter contains the Datatype if an attribute.

**`isArray`**

The out parameter which specifies whether the attribute is an array type.

1: if attribute is an array type.

0: if attribute is non-array type.

**Returns**

bool

true: if the accessing of attribute type is successful.

false: if the user tries to access a non-existing attribute.

### GetType Method (short, short, MxDataType, int)

Provides a method to get the type of an attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool GetType(
short attributeId,
short primitiveId,
out MxDataType dataType,
out int isArray
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`dataType`**

The out parameter contains the Datatype of an attribute.

**`isArray`**

The out parameter which specifies whether the attribute is an array type.

1: if the attribute is an array type.

0: if the attribute is non-array type

**Returns**

bool

true: if the accessing of attribute type is successful.

false: if the user tries to access a non-existing attribute.

### Initialize Method

Provides a method to initialize the wrapper to a Primitive by ID and IPrimitiveRuntimeSite.

**Syntax**

```csharp
public void Initialize(
short primitiveId,
IPrimitiveRuntimeSite pSite
);
```

**Parameters**

**`primitiveId`**

Primitive ID.

**`pSite`**

Object of IPrimitiveRuntimeSite.

### ParentPrimitive Method

Provides a method to get the Parent Primitive ID of a Primitive.

**Syntax**

```csharp
public short ParentPrimitive(short _primID);
```

**Parameters**

**`_primId`**

Primitive ID.

**Returns**

short

### PutBoolean Method (string, bool)

Provides a method to set the value of Boolean attribute by external name.

**Syntax**

```csharp
public bool PutBoolean(
string fullName,
bool value
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (short, short, bool)

Provides a method to set the value of Boolean attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutBoolean(
short attributeId,
short primitiveId,
bool value
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (string, bool, CMxDataQuality)

Provides a method to set the value and quality of Boolean attribute by name.

**Syntax**

```csharp
public bool PutBoolean(
string fullName,
bool value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (string, int, bool)

Provides a method to set the value of an element of a Boolean array attribute by name.

**Syntax**

```csharp
public bool PutBoolean(
string fullName,
int index,
bool value
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (short, short, bool, CMxDataQuality)

Provides a method to set the value and quality of Boolean attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutBoolean(
short attributeId,
short primitiveId,
bool value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (short, short, int, bool)

Provides a method to set the value of an element of a Boolean array attribute by ID, Primitive ID and index.

**Syntax**

```csharp
public bool PutBoolean(
short attributeId,
short primitiveId,
int index,
bool value
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (string, bool, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of Boolean attribute by name.

**Syntax**

```csharp
public bool PutBoolean(
string fullName,
bool value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method (short, short, bool, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a Boolean attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutBoolean(
short attributeId,
short primitiveId,
bool value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutBoolean Method Parameters and Return value.

**Returns**

Refer to the section PutBoolean Method Parameters and Return value.

### PutBoolean Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The Boolean value.

**`Index`**

The Boolean array index.

**`quality`**

The quality property for Boolean attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a Boolean attribute.

**Returns**

bool

true: if the Boolean attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutBooleanArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a Boolean array attribute by its external name.

**Syntax**

```csharp
public bool PutBooleanArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for Boolean array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Boolean array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutBooleanArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a Boolean array element by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutBooleanArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for Boolean array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Boolean array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutCustomEnum Method (string, short)

Provides a method to set the ordinal value of CustomEnum attribute by name.

**Syntax**

```csharp
public bool PutCustomEnum(
string fullName,
short value
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (short, short, short)

Provides a method to set the ordinal value of CustomEnum attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutCustomEnum(
short attributeId,
short primitiveId,
short value
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (string, int, short)

Provides a method to set the ordinal value of a CustomEnum array element by name.

**Syntax**

```csharp
public bool PutCustomEnum(
string fullName,
int index,
short value
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (string, short, CMxDataQuality)

Provides a method to set the ordinal value and quality of CustomEnum attribute by name.

**Syntax**

```csharp
public bool PutCustomEnum(
string fullName,
short value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (short, short, int, short)

Provides a method to set the ordinal value of CustomEnum array element by ID and Primitive ID.

**Syntax**

```csharp
public bool PutCustomEnum(
short attributeId,
short primitiveId,
int index,
short value
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (short, short, short, CMxDataQuality)

Provides a method to set the ordinal value and quality of CustomEnum attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutCustomEnum(
short attributeId,
short primitiveId,
short value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (string, short, DateTime, CMxDataQuality)

Provides a method to set the ordinal value, time, and quality of CustomEnum attribute by name.

**Syntax**

```csharp
public bool PutCustomEnum(
string fullName,
short value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value

### PutCustomEnum Method (short, short, short, DateTime, CMxDataQuality)

Provides a method to set the ordinal value, time, and quality of CustomEnum attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutCustomEnum(
short attributeId,
short primitiveId,
short value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomEnum Method Parameters and Return value.

**Returns**

Refer to the section PutCustomEnum Method Parameters and Return value.

### PutCustomEnum Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The ordinal value of CustomEnum attribute.

**`Index`**

The CustomEnum array index.

**`quality`**

The quality property for CustomEnum attribute.The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a CustomEnum attribute.

**Returns**

bool

true: if the CustomEnum attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutCustomEnumArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a CustomEnum array element by its external name.

**Syntax**

```csharp
public bool PutCustomEnumArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for CustomEnum array element . The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

true: if the CustomEnum array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutCustomEnumArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a CustomEnum array element by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutCustomEnumArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for CustomEnum array element . The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the CustomEnum array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutCustomStruct Method (string, MxCustomStruct)

Provides a method to set the value of a CustomStruct attribute by its external name.

**Syntax**

```csharp
public bool PutCustomStruct(
string fullName,
MxCustomStruct value
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (short, short, MxCustomStruct)

Provide a method to set the value of a CustomStruct attribute by its id and primitive id.

**Syntax**

```csharp
public bool PutCustomStruct(
short attributeId,
short primitiveId,
MxCustomStruct value
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (string, int, MxCustomStruct)

Provides a method to set the value of an element of a CustomStruct array attribute by its external name and index.

**Syntax**

```csharp
public bool PutCustomStruct(
string fullName,
int index,
MxCustomStruct value
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (string, MxCustomStruct, CMxDataQuality)

Provides a method to set the value and quality of a CustomStruct attribute by its external name.

**Syntax**

```csharp
public bool PutCustomStruct(
string fullName,
MxCustomStruct value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (short, short, int, MxCustomStruct)

Provides a method to set the value of an element of a CustomStruct array attribute by its id, primitive id, and index.

**Syntax**

```csharp
public bool PutCustomStruct(
short attributeId,
short primitiveId,
int index,
MxCustomStruct value
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (short, short, MxCustomStruct, CMxDataQuality)

Provides a method to set the value and quality of a CustomStruct attribute by its id and primitive id.

**Syntax**

```csharp
public bool PutCustomStruct(
short attributeId,
short primitiveId,
MxCustomStruct value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (string, MxCustomStruct, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a CustomStruct attribute by its external name.

**Syntax**

```csharp
public bool PutCustomStruct(
string fullName,
MxCustomStruct value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value

### PutCustomStruct Method (short, short, MxCustomStruct, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a CustomStruct attribute by its id and primitive id.

**Syntax**

```csharp
public bool PutCustomStruct(
short attributeId,
short primitiveId,
MxCustomStruct value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutCustomStruct Method Parameters and Return value.

**Returns**

Refer to the section PutCustomStruct Method Parameters and Return value.

### PutCustomStruct Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`guid`**

The guid of customstruct.

**`length`**

The length of the byte array.

**`Value`**

The byte array.

**`Index`**

The CustomStruct array index.

**`quality`**

The quality property for CustomStruct attribute.

**`time`**

The Date and Time for a CustomStruct attribute.

**Returns**

bool

true: if the CustomStruct attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutCustomStructArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a CustomStruct array element by its external name.

**Syntax**

```csharp
public bool PutCustomStructArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for CustomStruct array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the CustomStruct array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutCustomStructArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a CustomStruct array element by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutCustomStructArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for CustomStruct attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the CustomStruct array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutDouble Method (string, double)

Provides a method to set the value of a double attribute by name.

**Syntax**

```csharp
public bool PutDouble(
string fullName,
double value
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (short, short, double)

Provides a method to set the value of a double attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutDouble(
short attributeId,
short primitiveId,
double value
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (string, double, CMxDataQuality)

Provides a method to set the value and quality of a double attribute by name.

**Syntax**

```csharp
public bool PutDouble(
string fullName,
double value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (string, int, double)

Provides a method to set the value of a double array element by name.

**Syntax**

```csharp
public bool PutDouble(
string fullName,
int index,
double value
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (short, short, double, CMxDataQuality)

Provides a method to set the value and quality of a double attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutDouble(
short attributeId,
short primitiveId,
double value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (short, short, int, double)

Provides a method to set the value of an element of a double array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutDouble(
short attributeId,
short primitiveId,
int index,
double value
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (string, double, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a double attribute by name.

**Syntax**

```csharp
public bool PutDouble(
string fullName,
double value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value

**Returns**

Refer to the section PutDouble Method Parameters and Return value

### PutDouble Method (short, short, double, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a double attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutDouble(
short attributeId,
short primitiveId,
double value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutDouble Method Parameters and Return value.

**Returns**

Refer to the section PutDouble Method Parameters and Return value.

### PutDouble Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The Double value.

**`Index`**

The Double array index.

**`quality`**

The quality property for Double attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a Double attribute.

**Returns**

bool

true: if the Double attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutDoubleArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a double array element by its external name.

**Syntax**

```csharp
public bool PutDoubleArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for double attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the double array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutDoubleArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a double array element by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutDoubleArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for double array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the double array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutElapsedTime Method (string, TimeSpan)

Provides a method to set the value of an ElapsedTime attribute by its external name.

**Syntax**

```csharp
public bool PutElapsedTime(
string fullName,
TimeSpan value
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (short, short, TimeSpan)

Provides a method to set the value of an ElapsedTime attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutElapsedTime(
short attributeId,
short primitiveId,
TimeSpan value
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (string, int, TimeSpan)

Provides a method to set the value of an element of an ElapsedTime array attribute by its name.

**Syntax**

```csharp
public bool PutElapsedTime(
string fullName,
int index,
TimeSpan value
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (string, TimeSpan, CMxDataQuality)

Provides a method to set the value and quality of an ElapsedTime attribute by its name.

**Syntax**

```csharp
public bool PutElapsedTime(
string fullName,
TimeSpan value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (short, short, int, TimeSpan)

Provides a method to set the value of an element of an ElapsedTime array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutElapsedTime(
short attributeId,
short primitiveId,
int index,
TimeSpan value
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (short, short, TimeSpan, CMxDataQuality)

Provides a method to set the value and quality of an ElapsedTime attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutElapsedTime(
short attributeId,
short primitiveId,
TimeSpan value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (string, TimeSpan, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of an ElapsedTime attribute by its name.

**Syntax**

```csharp
public bool PutElapsedTime(
string fullName,
TimeSpan value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value

### PutElapsedTime Method (short, short, TimeSpan, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of an ElapsedTime attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutElapsedTime(
short attributeId,
short primitiveId,
TimeSpan value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutElapsedTime Method Parameters and Return value.

**Returns**

Refer to the section PutElapsedTime Method Parameters and Return value.

### PutElapsedTime Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The ElapsedTime value.

**`Index`**

The ElapsedTime array index.

**`quality`**

The quality property for ElapsedTime attribute.

**`time`**

The Date and Time for a ElapsedTime attribute.

**Returns**

bool

true: if the ElapsedTime attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutElapsedTimeArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a ElapsedTime array element by its external name.

**Syntax**

```csharp
public bool PutElapsedTimeArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for ElapsedTime array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the ElapsedTime array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutElapsedTimeArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of an ElapsedTime array element by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutElapsedTimeArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for ElapsedTime array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the ElapsedTime array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutFloat Method (string, float)

Provides a method to set the value of a float attribute by its external name.

**Syntax**

```csharp
public bool PutFloat(
string fullName,
float value
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (short, short, float)

Provides a method to set the value of a float attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutFloat(
short attributeId,
short primitiveId,
float value
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (string, float, CMxDataQuality)

Provides a method to set the value and quality of a float attribute by its name.

**Syntax**

```csharp
public bool PutFloat(
string fullName,
float value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (string, int, float)

Provides a method to set the value of an element of a float array attribute by its name.

**Syntax**

```csharp
public bool PutFloat(
string fullName,
int index,
float value
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (short, short, float, CMxDataQuality)

Provides a method to set the value and quality of a float attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutFloat(
short attributeId,
short primitiveId,
float value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (short, short, int, float)

Provides a method to set the value of an element of a float array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutFloat(
short attributeId,
short primitiveId,
int index,
float value
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (string, float, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a float attribute by its name.

**Syntax**

```csharp
public bool PutFloat(
string fullName,
float value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value

**Returns**

Refer to the section PutFloat Method Parameters and Return value

### PutFloat Method (short, short, float, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a float attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutFloat(
short attributeId,
short primitiveId,
float value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutFloat Method Parameters and Return value.

**Returns**

Refer to the section PutFloat Method Parameters and Return value.

### PutFloat Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The Float value.

**`Index`**

The Float array index.

**`quality`**

The quality property for Float attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a Float attribute.

**Returns**

bool

true: if the Float attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutFloatArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a Float array element by its external name.

**Syntax**

```csharp
public bool PutFloatArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for Float array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Float array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutFloatArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a Float array element by its external ID and Primitive ID.

**Syntax**

```csharp
public bool PutFloatArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for Float array element. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Float array element quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutInteger Method (string, int)

Provides a method to set the value of an Integer attribute by its external name.

**Syntax**

```csharp
public bool PutInteger(
string fullName,
int value
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (short, short, int)

Provides a method to set the value of an Integer attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutInteger(
short attributeId,
short primitiveId,
int value
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (string, int, CMxDataQuality)

Provides a method to set the value and quality of an Integer attribute by name.

**Syntax**

```csharp
public bool PutInteger(
string fullName,
int value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (string, int, int)

Provides a method to set the value of an element of an Integer array attribute by name.

**Syntax**

```csharp
public bool PutInteger(
string fullName,
int index,
int value
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (short, short, int, CMxDataQuality)

Provides a method to set the value and quality of an Integer attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutInteger(
short attributeId,
short primitiveId,
int value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (short, short, int, int)

Provides a method to set the value of an element of an Integer array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutInteger(
short attributeId,
short primitiveId,
int index,
int value
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (string, int, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of an Integer attribute by name.

**Syntax**

```csharp
public bool PutInteger(
string fullName,
int value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value

**Returns**

Refer to the section PutInteger Method Parameters and Return value

### PutInteger Method (short, short, int, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of an Integer attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutInteger(
short attributeId,
short primitiveId,
int value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutInteger Method Parameters and Return value.

**Returns**

Refer to the section PutInteger Method Parameters and Return value.

### PutInteger Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The Integer value.

**`Index`**

The Integer array index.

**`quality`**

The quality property for an Integer attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for an Integer attribute.

**Returns**

bool

true: if the Integer attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutIntegerArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of an Integer array attribute by its external name.

**Syntax**

```csharp
public bool PutIntegerArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for an Integer array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Integer array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutIntegerArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of an Integer array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutIntegerArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for an Integer array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Integer array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutMxDataType Method (string, MxDataType)

Provides a method to set the value of a MxDataType attribute by its external name.

**Syntax**

```csharp
public bool PutMxDataType(
string fullName,
MxDataType value
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value

### PutMxDataType Method (short, short, MxDataType)

Provides a method to set the value of a MxDataType attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxDataType(
short attributeId,
short primitiveId,
MxDataType value
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method (string, int, MxDataType)

Provides a method to set the value of an element of an MxDataType array attribute by name.

**Syntax**

```csharp
public bool PutMxDataType(
string fullName,
int index,
MxDataType value
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method (string, MxDataType, CMxDataQuality)

Provides a method to set the value and quality of a MxDataType attribute by name.

**Syntax**

```csharp
public bool PutMxDataType(
string fullName,
MxDataType value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method (short, short, int, MxDataType)

Provides a method to set the value of an element of an MxDataType array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxDataType(
short attributeId,
short primitiveId,
int index,
MxDataType value
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method (short, short, MxDataType, CMxDataQuality)

Provides a method to set the value and quality of a MxDataType attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxDataType(
short attributeId,
short primitiveId,
MxDataType value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method (string, MxDataType, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a MxDataType attribute by name.

**Syntax**

```csharp
public bool PutMxDataType(
string fullName,
MxDataType value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method (short, short, MxDataType, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a MxDataType attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxDataType(
short attributeId,
short primitiveId,
MxDataType value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxDataType Method Parameters and Return value.

**Returns**

Refer to the section PutMxDataType Method Parameters and Return value.

### PutMxDataType Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The MxDataType value. The supported MxDataType values are:

MxBigString, MxBoolean, MxDataQualityType, MxDataTypeEND, MxDataTypeEnum, MxDataTypeUnknown, MxDouble, MxElapsedTime, MxFloat, MxInteger, MxInternationalizedString, MxNoData, MxQualifiedEnum, MxQualifiedStruct, MxReferenceType, MxSecurityClassificationEnum, MxStatusType, MxString, and MxTime.

**`Index`**

The MxDataType array index.

**`quality`**

The quality property for MxDataType attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for MxDataType attribute.

**Returns**

bool

true: if the MxDataType attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutMxDataTypeArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a MxDataType array attribute by its external name.

**Syntax**

```csharp
public bool PutMxDataTypeArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of the attribute.

**`quality`**

The quality property for MxDataType array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the MxDataType array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutMxDataTypeArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a MxDataType array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxDataTypeArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for MxDataType array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the MxDataType array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutMxStatus Method (string, MxStatus)

Provides a method to set the value of a MxStatus attribute by its external name.

**Syntax**

```csharp
public bool PutMxStatus(
string fullName,
MxStatus value
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value

### PutMxStatus Method (short, short, MxStatus)

Provides a method to set the value of a MxStatus attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxStatus(
short attributeId,
short primitiveId,
MxStatus value
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value.

### PutMxStatus Method (string, int, MxStatus)

Provides a method to set the value of an element of an MxStatus array attribute by name.

**Syntax**

```csharp
public bool PutMxStatus(
string fullName,
int index,
MxStatus value
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value

### PutMxStatus Method (string, MxStatus, CMxDataQuality)

Provides a method to set the value and quality of a MxStatus attribute by name.

**Syntax**

```csharp
public bool PutMxStatus(
string fullName,
MxStatus value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value.

### PutMxStatus Method (short, short, int, MxStatus)

Provides a method to set the value of an element of an MxStatus array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxStatus(
short attributeId,
short primitiveId,
int index,
MxStatus value
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value.

### PutMxStatus Method (short, short, MxStatus, CMxDataQuality)

Provides a method to set the value and quality of a MxStatus attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxStatus(
short attributeId,
short primitiveId,
MxStatus value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value.

### PutMxStatus Method (string, MxStatus, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a MxStatus attribute by name.

**Syntax**

```csharp
public bool PutMxStatus(
string fullName,
MxStatus value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value.

### PutMxStatus Method (short, short, MxStatus, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a MxStatus attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxStatus(
short attributeId,
short primitiveId,
MxStatus value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutMxStatus Method Parameters and Return value.

**Returns**

Refer to the section PutMxStatus Method Parameters and Return value.

### PutMxStatus Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The MxStatus value. The MxStatus value can set as shown below:

MxStatus sval = new MxStatus();

sval.success = -1;

sval.Category = MxStatusCategory.MxCategoryOk;

sval.detail = 1;

sval.detectedBy = MxStatusSource.MxSourceRequestingAutomationObject;

PutMxStatus("StatusAttr", sval);

**`Index`**

The MxStatus array index.

**`quality`**

The quality property for MxStatus attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for MxStatus attribute.

**Returns**

bool

true: if the MxStatus attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutMxStatusArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a MxDataType array attribute by its external name.

**Syntax**

```csharp
public bool PutMxStatusArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of attribute.

**`quality`**

The quality property for MxStatus array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if MxStatus array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutMxStatusArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a MxDataType array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutMxStatusArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for MxStatus array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if MxStatus array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutQuality Method (string, MxDataType, CMxDataQuality)

Provides a method to set the quality of an attribute by its name.

**Syntax**

```csharp
public bool PutQuality(
string fullName,
MxDataType dataType,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutQuality Method Parameters and Return value.

**Returns**

Refer to the section PutQuality Method Parameters and Return value.

### PutQuality Method (short, short, MxDataType, CMxDataQuality)

Provides a method to set the quality of an attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutQuality(
short attributeId,
short primitiveId,
MxDataType dataType,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutQuality Method Parameters and Return value.

**Returns**

Refer to the section PutQuality Method Parameters and Return value.

### PutQuality Method Parameters and Return value

**Parameters**

**`fullName`**

External name of an attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`dataType`**

The Datatype of an attribute. The supported datatypes are:

MxBoolean

MxInteger

MxFloat

MxDouble

MxString

MxTime

MxElapsedTime

MxReferenceType

MxStatusType

MxDataTypeEnum

MxQualifiedEnum

MxQualifiedStruct

**`quality`**

The quality property of an attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutReference Method (string, IMxReference)

Provides a method to set the value of reference attribute by its external name.

**Syntax**

```csharp
public bool PutReference(
string fullName,
IMxReference value
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method (short, short, IMxReference)

Provides a method to set the value of reference attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutReference(
short attributeId,
short primitiveId,
IMxReference value
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method (string, IMxReference, CMxDataQuality)

Provides a method to set the value and quality of reference attribute by name.

**Syntax**

```csharp
public bool PutReference(
string fullName,
IMxReference value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value

**Returns**

Refer to the section PutReference Method Parameters and Return value

### PutReference Method (string, int, IMxReference)

Provides a method to set the value of an element of a reference array attribute by name.

**Syntax**

```csharp
public bool PutReference(
string fullName,
int index,
IMxReference value
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method (short, short, IMxReference, CMXDataQuality)

Provides a method to set the value and quality of reference attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutReference(
short attributeId,
short primitiveId,
IMxReference value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method (short, short, int, IMxReference)

Provides a method to set the value of an element of a reference array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutReference(
short attributeId,
short primitiveId,
int index,
IMxReference value
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method (string, IMxReference, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of reference attribute by name.

**Syntax**

```csharp
public bool PutReference(
string fullName,
IMxReference value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method (short, short, IMxReference, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of reference attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutReference(
short attributeId,
short primitiveId,
IMxReference value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutReference Method Parameters and Return value.

**Returns**

Refer to the section PutReference Method Parameters and Return value.

### PutReference Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The Reference attribute value. The value can be set by IMxReference:

IMxReference val;

val.FullReferenceString = "Sample String";

PutReference("ReferenceAttr", val);

**`Index`**

The Reference array index.

**`quality`**

The quality property for Reference attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a Reference attribute.

**Returns**

bool

true: if the Reference attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutReferenceArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a Reference array attribute by its external name.

**Syntax**

```csharp
public bool PutReferenceArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of attribute.

**`quality`**

The quality property for Reference array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if Reference array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutReferenceArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a Reference array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutReferenceArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for Reference array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if Reference array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutString Method (string, string)

Provides a method to set the value of a string attribute by its external name.

**Syntax**

```csharp
public bool PutString(
string fullName,
string value
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (short, short, string)

Provides a method to set the value of a string attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutString(
short attributeId,
short primitiveId,
string value
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (string, int, string)

Provides a method to set the value of an element of a string array attribute by name.

**Syntax**

```csharp
public bool PutString(
string fullName,
int index,
string value
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (string, string, CMxDataQuality)

Provides a method to set the value and quality of a string attribute by name.

**Syntax**

```csharp
public bool PutString(
string fullName,
string value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (short, short, int, string)

Provides a method to set the value of an element of a string array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutString(
short attributeId,
short primitiveId,
int index,
string value
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (short, short, string, CMxDataQuality)

Provides a method to set the value and quality of a string attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutString(
short attributeId,
short primitiveId,
string value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (string, string, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a string attribute by name.

**Syntax**

```csharp
public bool PutString(
string fullName,
string value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method (short, short, string, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a string attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutString(
short attributeId,
short primitiveId,
string value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutString Method Parameters and Return value.

**Returns**

Refer to the section PutString Method Parameters and Return value.

### PutString Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The string value.

**`Index`**

The string array index.

**`quality`**

The quality property for string attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a string attribute.

**Returns**

bool

true: if the string attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutStringArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a string array attribute by its external name.

**Syntax**

```csharp
public bool PutStringArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of attribute.

**`quality`**

The quality property for string array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the string array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutStringArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a string array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutStringArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for string array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the string array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutTime Method (string, VBFILETIME)

Provides a method to set the value of a time attribute by its external name.

**Syntax**

```csharp
public bool PutTime(
string fullName,
ref VBFILETIME value
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value.

**Returns**

Refer to the section PutTime Method Parameters and Return value.

### PutTime Method (short, short, VBFILETIME)

Provides a method to set the value of a time attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutTime(
short attributeId,
short primitiveId,
ref VBFILETIME value
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value.

**Returns**

Refer to the section PutTime Method Parameters and Return value.

### PutTime Method (string, int, VBFILETIME)

Provides a method to set the value of an element of a time array attribute by name.

**Syntax**

```csharp
public bool PutTime(
string fullName,
int index,
ref VBFILETIME value
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value.

**Returns**

Refer to the section PutTime Method Parameters and Return value.

### PutTime Method (string, VBFILETIME, CMxDataQuality)

Provides a method to set the value and quality of a time attribute by name.

**Syntax**

```csharp
public bool PutTime(
string fullName,
ref VBFILETIME value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value.

**Returns**

Refer to the section PutTime Method Parameters and Return value.

### PutTime Method (short, short, int, VBFILETIME)

Provides a method to set the value of an element of a time array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutTime(
short attributeId,
short primitiveId,
int index,
ref VBFILETIME value
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value

**Returns**

Refer to the section PutTime Method Parameters and Return value

### PutTime Method (short, short, VBFILETIME, CMxDataQuality)

Provides a method to set the value and quality of a time attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutTime(
short attributeId,
short primitiveId,
ref VBFILETIME value,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value

**Returns**

Refer to the section PutTime Method Parameters and Return value

### PutTime Method (string, VBFILETIME, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a time attribute by name.

**Syntax**

```csharp
public bool PutTime(
string fullName,
ref VBFILETIME value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value

**Returns**

Refer to the section PutTime Method Parameters and Return value

### PutTime Method (short, short, VBFILETIME, DateTime, CMxDataQuality)

Provides a method to set the value, time, and quality of a time attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutTime(
short attributeId,
short primitiveId,
ref VBFILETIME value,
DateTime time,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section PutTime Method Parameters and Return value.

**Returns**

Refer to the section PutTime Method Parameters and Return value.

### PutTime Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`Value`**

The Time attribute value. The Time value can be set as shown below:

VBFILETIME val = CMxValue.DateTimeToVBFT(DateTime.Now);

PutTime("TimeAttr", ref val);

**`Index`**

The Time array index.

**`quality`**

The quality property for Time attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**`time`**

The Date and Time for a Time attribute.

**Returns**

bool

true: if the Time attribute setting is successful.

false: if the user tries to access a non-existing attribute.

### PutTimeArrayQ Method (string, CMxDataQuality)

Provides a method to set the quality of a Time array attribute by its external name.

**Syntax**

```csharp
public bool PutTimeArrayQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

**`fullName`**

External name of attribute.

**`quality`**

The quality property for Time array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Time array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutTimeArrayQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of a Time array attribute by its ID and Primitive ID.

**Syntax**

```csharp
public bool PutTimeArrayQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property for Time array attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

**Returns**

bool

true: if the Time array attribute quality setting is successful.

false: if the user tries to access a non-existing attribute.

### PutTimeStamp Method (string, MxDataType, DateTime)

Provides a method to set the time of an attribute by name.

**Syntax**

```csharp
public bool PutTimeStamp(
string fullName,
MxDataType dataType,
DateTime time
);
```

**Parameters**

Refer to the section PutTimeStamp Method Parameters and Return value

**Returns**

Refer to the section PutTimeStamp Method Parameters and Return value

### PutTimeStamp Method (short, short, MxDataType, DateTime)

Provides a method to set the time of an attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool PutTimeStamp(
short attributeId,
short primitiveId,
MxDataType dataType,
DateTime time
);
```

**Parameters**

Refer to the section PutTimeStamp Method Parameters and Return value.

**Returns**

Refer to the section PutTimeStamp Method Parameters and Return value.

### PutTimeStamp Method Parameters and Return value

**Parameters**

**`fullName`**

External name of an attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`dataType`**

The Datatype of an attribute. The supported datatype are:

MxBoolean

MxInteger

MxFloat

MxDouble

MxString

MxTime

MxElapsedTime

MxReferenceType

MxStatusType

MxDataTypeEnum

MxQualifiedEnum

MxQualifiedStruct

**`time`**

The time property of an attribute.

**Returns**

bool

true: if the attribute time setting is successful.

false: if the user tries to access a non-existing attribute.

### RecreateDynamicAttributes Method

Provides a method to recreate dynamic attributes supported by failover.

**Syntax**

```csharp
public void RecreateDynamicAttributes();
```

### RestoreDynamicAttributes Method

Provides a method to recreate dynamic attributes supported by failover and set their value if the object is starting up from standby. Use this method to restore the dynamic attribute’s values if the startup context is Checkpoint or Failover.

**Syntax**

```csharp
public void RestoreDynamicAttributes();
```

### SendEvent Method

Provides a method to cause an Attributes Set Handler to execute using the Attributes External Name (report a data change).

**Syntax**

```csharp
public bool SendEvent(
string name,
string oldValue,
string newValue,
string description
);
```

**Parameters**

**`name`**

External name of an attribute.

**`oldValue`**

Old value of an attribute.

**`newValue`**

New value of an attribute.

**`description`**

The custom string specifies the description of change.

**Returns**

bool

### SetDataToFailoverField Method

Provides a method to set a C# object to the failover attribute.

**Syntax**

```csharp
public void SetDataToFailoverField(object data);
```

**Parameters**

**`data`**

The data object.

### SetHandler Method

Provides a method to perform custom execution logic based upon a change of data for a particular attribute.

**Syntax**

```csharp
public void SetHandler(
ref AttributeHandle pAttributeHandle,
ref SetInfo pInfo,
IMxValue pMxValue,
ref MxStatus pMxStatus
);
```

**Parameters**

**`pAttributeHandle`**

Specifies which property of which attribute is attempting to be set.

**`pInfo`**

Specifies additional information regarding this set attribute.

**`pMxValue`**

Specifies the value of the property to be set.

**`pMxStatus`**

Specifies the return status of the set.

### SetNumElementsEx Method (string, int)

Provides a method to set the number of elements of an array attribute by name.

**Syntax**

```csharp
public bool SetNumElementsEx(
string fullName,
int numElements
);
```

**Parameters**

**`fullName`**

Name of an array attribute.

**`numElements`**

The number of elements of an array attribute.

**Returns**

bool

true: if the array attribute number of elements setting is successful.

false: if the user tries to access a non-existing attribute.

### SetNumElementsEx Method (short, short, int)

Provides a method to set the number of elements of an array attribute by ID and Primitive ID.

**Syntax**

```csharp
public bool SetNumElementsEx(
short attributeId,
short primitiveId,
int numElements
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`numElements`**

The number of elements of an array attribute.

**Returns**

bool

true: if the array attribute number of elements setting is successful.

false: if the user tries to access a non-existing attribute.

### SetQ Method (string, CMxDataQuality)

Provides a method to set the quality of an attribute by name.

**Syntax**

```csharp
public void SetQ(
string fullName,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section SetQ Method Parameters and Return value

### SetQ Method (short, short, CMxDataQuality)

Provides a method to set the quality of an attribute by ID and Primitive ID.

**Syntax**

```csharp
public void SetQ(
short attributeId,
short primitiveId,
CMxDataQuality quality
);
```

**Parameters**

Refer to the section SetQ Method Parameters and Return value.

### SetQ Method Parameters and Return value

**Parameters**

**`fullName`**

External name of the attribute.

**`attributeId`**

Attribute ID.

**`primitiveId`**

Primitive ID of an attribute.

**`quality`**

The quality property of an attribute. The supported quality types are:

DataQualityBad

DataQualityGood

DataQualityInitializing

DataQualityUncertain

DataQualityUnknown

### SetScanState Method

Provides a wrapper to fire the SetScanState event.

**Syntax**

```csharp
public void SetScanState(bool bOnScan);
```

**Parameters**

**`bOnScan`**

true: OnScan state.

false: OffScan state.

### StandbyStartup Method

Provide indication if object is starting up from standby.

**Syntax**

```csharp
public bool StandbyStartup();
```

**Returns**

bool

### SuspendLocalAttribute Method (string)

Provides a method to suspend an attribute. This function is called by auto-generated toolkit code and is typically not to be used by the Object Developer.

**Syntax**

```csharp
public bool SuspendLocalAttribute(
string attributeName
);
```

**Parameters**

**`attributeName`**

External name of an attribute.

**Returns**

bool

### SuspendLocalAttribute Method (short, string)

Provides a method to activate an attribute. This function is called by auto-generated toolkit code and is not to be used by the Object Developer.

**Syntax**

```csharp
public bool SuspendLocalAttribute(
short attributeId,
string attributeName
);
```

**Parameters**

**`attributeId`**

Attribute ID.

**`attributeName`**

External name of an attribute.

**Returns**

bool

### SuspendPrimitiveAttribute Method (string)

Provides a method to suspend an attribute of a child primitive, reusable primitive, or an utility primitive.

**Syntax**

```csharp
public bool SuspendPrimitiveAttribute(
string fullAttributeName
);
```

**Parameters**

**`fullAttributeName`**

The name of the primitive attribute. The name fullAttributeName format should be "PrimitiveName.AttributeName".

**Returns**

bool

### SuspendPrimitiveAttribute Method (short, short)

Provides a method to activate an attribute of a child primitive, reusable primitive, or utility primitive.

**Syntax**

```csharp
public bool SuspendPrimitiveAttribute(
short attributeId,
short primitiveId
);
```

**Parameters**

**`attributeId`**

The primitive's attribute ID.

**`primitiveId`**

Primitive ID.

**Returns**

bool

### UpdateDynamicAttributeData Method

Provides a method to update each dynamic attribute registered for failover with its current name, type, category, security, and set handler flag.

**Syntax**

```csharp
public void UpdateDynamicAttributeData();
```

## Nested Type: InputOutputPrimitive Class

This class provides a wrapper for the InputOutput Primitive.

**Syntax**

```csharp
public class InputOutputPrimitive : RuntimeBase.PrimitiveWrapper
```

**Remarks**

The InputOutputPrimitive is derived from RuntimeBase.PrimitiveWrapper and it contains the properties, attributes, and methods associated with the InputOutput Primitives.

### InputOutputPrimitive Properties

### InputOutputPrimitive Constructor

### InputOutputPrimitive Methods

## Nested Type: InputPrimitive Class

This class provides a wrapper for Input Primitive.

**Syntax**

```csharp
public class InputPrimitive : RuntimeBase.PrimitiveWrapper
```

**Remarks**

The InputPrimitive is derived from RuntimeBase.PrimitiveWrapper and it contains the properties, attributes, and methods associated with the InputPrimitives.

### InputPrimitive Properties

### InputPrimitive Constructor

### InputPrimitive Methods

## Nested Type: OutputPrimitive Class

This class provides a wrapper for Output Primitive.

**Syntax**

```csharp
public class OutputPrimitive : RuntimeBase.PrimitiveWrapper
```

**Remarks**

The OutputPrimitive is derived from RuntimeBase.PrimitiveWrapper and it contains the properties, attributes, and methods associated with the OutputPrimitives.

### OutputPrimitive Properties

### OutputPrimitive Constructor

### OutputPrimitive Methods

## Nested Type: PrimitiveWrapper Class

This class is the base class of all IO Wrappers.

**Syntax**

```csharp
public class PrimitiveWrapper
```

### PrimitiveWrapper Property

### PrimitiveWrapper Constructor

### PrimitiveWrapper Methods
